from sys import setrecursionlimit
import threading

setrecursionlimit(10 ** 8)
threading.stack_size(67108864 // 2)


def main():
    def f(n: int, q: set) -> set:
        if n == 1:
            return q
        p = set()
        for i in range(2, len(fibs)):
            if not n % fibs[i]:
                t = q.copy()
                if n // fibs[i] in dp:
                    d = dp[n // fibs[i]]
                else:
                    d = f(n // fibs[i], t)
                for x in d:
                    p.add(tuple(sorted(x + (fibs[i],))))
        dp[n] = p.copy()
        return p

    dp = {}
    fibs = [0] * 30
    fibs[0] = fibs[1] = 1
    for i in range(2, 30):
        fibs[i] = fibs[i - 1] + fibs[i - 2]
    for _ in range(int(input())):
        n = int(input())
        x = (0, 0)
        s = set((x, x,))
        print(len(f(n, s)))


thread = threading.Thread(target=main)
thread.start()
