#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

map<ll, set<multiset<ll>>> dp;
vector<ll> fibs;

set<multiset<ll>> f(ll n, set<multiset<ll>> q) {
    if (n == 1) return q;
    set<multiset<ll>> p;
    for (int i = 2; i < 88; i++) {
        if (!(n % fibs[i])) {
            //set<multiset<ll>> t = q;
            set<multiset<ll>> d;
            if (dp.find(n / fibs[i]) != dp.end()) d = dp[n / fibs[i]];
            else d = f(n / fibs[i], q);
            for (auto x: d) {
                x.insert(fibs[i]);
                p.insert(x);
            }
        }
    }
    dp[n] = p;
    return p;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    fibs.resize(88);
    fibs[0] = 1;
    fibs[1] = 1;
    for (int i = 2; i < 88; i++) {
        fibs[i] = fibs[i - 1] + fibs[i - 2];
    }
    int t;
    cin >> t;
    while (t--) {
        ll n;
        cin >> n;
        cout << f(n, set<multiset<ll>> {multiset<ll> {}}).size() << '\n';
    }
    return 0;
}
